! this include file has a lot of /asl/data/kcarta so that the
! SRCv1.20/Makefile uses SED, changing them to actual distribution directory DISTDIR

!cc sed so /asl/data/kcarta/KCDATA/ becomes /asl/data/kcarta/KCDATA
!cc sed so /asl/data/kcarta_sergio/KCDATA/ becomes /asl/data/kcarta_sergio/KCDATA

! this include file has parameters to compile kcartamain.f, kcartabasic.f
! using pre_definedparam.f90, parameters are set here depending on what
! the user specifies

! DO NOT TOUCH pre_definedparam.f90 and post_definedparam.f90

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!! PRE DEFINED PARAMETERS!! DO NOT TOUCH!! !!!!!!!!!!!!!!!!!!
!!!!                                                                  !!!
      include '../INCLUDE/pre_definedparam.f90'                          !!!
! template file : template_kcartaV120_400_H2016.param                 !!!
!2345678901234567890123456789012345678901234567890123456789012345678901234567890
!!!!!!!!!!!!!!!!!!!!!!!!!!!12345678901234567890123456789012345678901234567890123456789012345678901234567890
      PARAMETER(caVersion='v1.20 18-03-26 template_kcartaV120_400_H2016_NLTEH2016.param')      !!!
!!!!                       v     YY MM DD template_kcartaV120_PPM_H20XY_NLTEH20AB.param')      !!!
!!!!                                                                  !!!
!!!!!!!!!!!!!! PRE DEFINED PARAMETERS!! DO NOT TOUCH!! !!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!************************************************************************
!************* cccc USER DEFINED INFORMATION cccc ***********************
!******************* set these as desired *******************************
!************************************************************************

! kOrigRefPath == path to original 100 layers reference profiles
!              == these profiles were used in making the kCARTA database
      CHARACTER*80 kOrigRefPath
      PARAMETER (kOrigRefPath = &
                '/asl/data/kcarta_sergio/KCDATA/RefProf_July2010.For.v115up_CO2ppmv400/')

! need paths to comp.param and xsec.param == files that detail what gasID's
! and frequency combinations are in the compressed/crosssection databases
! parameter kChiFIle tells the code where to look for necessary files
! that improve the spectroscopy when multiplied with the kCompressed data
      CHARACTER*80 kXsecParamFile,kCompParamFile
      PARAMETER (kXsecParamFile = &
         '/home/sergio/KCARTA/SCRIPTS/MAKE_COMP_HTXY_PARAM_SC/PARAM_HT2016/comp_ir605_2830.param')

! ******* make sure this agrees with the IR CO2 database set in kCO2Path
! ******* make sure this agrees with the IR CO2 database set in kCO2Path
! ******* make sure this agrees with the IR CO2 database set in kCO2Path

! this has new H2016 for all bands (FIR7,FIR6 .. FIR1,IR,NIR1) and old, TRIED AND TESTED UMBC CO2 linemixing
      PARAMETER (kCompParamFile = &
         '/home/sergio/KCARTA/SCRIPTS/MAKE_COMP_HTXY_PARAM_SC/PARAM_HT2016/comp_ir605_2830.param')

! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
! >>>>>>>>>>>>>>>>> little endian vs big endian data files <<<<<<<<<<<<<
! >>>>>>>> set correct path (iee_le vs ieee_be) as necessary <<<<<<<<<<<
! >>>>>>>> change ieee-le to ieee-be for Intel vs SGI <<<<<<<<<<<<<<<<<<
! DISTDIR = /asl/data/kcarta is ieee-le, while /strowlab/motteler is ieee-be
! --------- > (A) these are the water files, and ALL gases EXCEPT CO2
! kWaterPath      == path to compressed files for water
!                   (note gases 101,102 use lookup tables for self, foreign
!                   contribution to the continuum)
! kCompPath       == path to other compressed data files (gasID 3 - 27,51-63)
! kCKDPath        == path to where the CKD lookup tables are
! kCKD_compr_path == path to where the CKD compressed data files (gasID 101,102)
! note : this is default, for the "r" or regular gases in 605-2830 cm-1 range
      CHARACTER*120 kWaterPath,kCompPath,kCKDPath,kCKD_compr_path
      PARAMETER (kWaterPath      = '/asl/data/kcarta/H2016.ieee-le/IR605/hdo.ieee-le/')
      PARAMETER (kCompPath       = '/asl/data/kcarta/H2016.ieee-le/IR605/etc.ieee-le/')
      PARAMETER (kCKDPath        = '/asl/data/kcarta_sergio/KCDATA/General/CKDieee_le/')
      PARAMETER (kCKD_Compr_Path = '/asl/data/kcarta_sergio/KCDATA/General/CKDieee_le/Compr/')

! this is to account for heavy water in the 605-2830, 2830-3330 cm-1 bands
! These are the 0,0025 cm-1 resolution bands
! so first     band starts at 0605 and ends at 1955 cm-1 (ie last chunk is 1930 cm-1)
! while second band starts at 1955 and ends at 3555 cm-1 (ie last chunk is 3530 cm-1)
! >>>>>>> NOTE that ALL the water isotope datafiles are in kWaterIsotopePath
! >>>>>>> so the  605-2830 cm-1 "rX_gY.dat" and
! >>>>>>>        2830-3555 cm-1 "sX_gY.dat" files should all be in that dir
      CHARACTER*80 kWaterIsotopePath
      PARAMETER (kWaterIsotopePath = '/asl/data/kcarta/H2016.ieee-le/IR605/hdo.ieee-le/')
      INTEGER kWaterIsobandStart1,kWaterIsobandStop1
      INTEGER kWaterIsobandStart2,kWaterIsobandStop2
      PARAMETER (kWaterIsobandStart1 = 0605, kWaterIsobandStop1 = 1955)
      PARAMETER (kWaterIsobandStart2 = 1955, kWaterIsobandStop2 = 3355)
! for testing; this will turn off new part of code and just use usual database
! for testing; this will turn off new part of code and just use usual database
!      PARAMETER (kWaterIsotopePath = kWaterPath)
!      PARAMETER (kWaterIsobandStart1 = 2905, kWaterIsobandStop1 = 3355)
!      PARAMETER (kWaterIsobandStart2 = 3905, kWaterIsobandStop2 = 3355)

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      CHARACTER*80 kCousin_CO2Path,kChiFile
! kCousin_CO2Path == path to alt (cousin) CO2 compressed data files (gasID 2)
! kChiFile        == path to any chi files (for eg CO2 and H20)
!                    kChiFile tells the code where to look for necessary files
!                    that improve spectroscopy (they multiply kCompressed
!                    optical depths) to get smaller radiance biases (as
!                    determined by analyzing AIRS radiances)
!                    Also used in NLTE as it uses simple linemix model in
!                    the 2355-2505 region, which needs to agree better with
!                    UMBC-LBL model
!        would need to set iType = 0 in kcoeffMAIN.f for no fudges
! this is the Cousin LineShape file, with 370 ppmv
      PARAMETER (kCousin_CO2Path = '/asl/data/kcarta/v10.ieee-le/etc.ieee-le/')
! this is the chifiles
      PARAMETER (kChiFile        = '/asl/data/kcarta_sergio/KCDATA/General/ChiFile/')
!cccccc >>>>>>>>

! kCO2Path        == path to main linemix CO2 compressed data files (gasID 2)
      CHARACTER*80 kCO2Path
! ---------->     kCO2_UMBCorHARTMAN tells us linemixing = +1 for UMBC, -1 for Hartmann
      INTEGER kCO2_UMBCorHARTMAN
! NEW versions, first is what was used, tried and tested in SARTA from 2004-2012
      PARAMETER (kCO2Path = '/asl/data/kcarta_sergio/UMBC_CO2_H1998.ieee-le/CO2ppmv400.ieee-le/')  !! default UMBC best
      PARAMETER (kCO2_UMBCorHARTMAN = +1)

! kCO2ppmvFile      == file that has the CO2 amounts used in the LTE kCARTA database
! kCO2ppmvFileBack  == file that has the CO2 amounts used in the weak backgnd
!                         LTE kCARTA database, layers 1 .. 100
! kCO2ppmvFileBackUS== file that has the CO2 amounts used in the weak backgnd
!                         UA LTE kCARTA database, alyers 101 - 120
! kCO2ppmv       == CO2 ppmv used in the kCARTA database, for LTE 1 .. 100 layers
      CHARACTER*80 kCO2ppmvFile,kCO2ppmvFileBack,kCO2ppmvFileBackUA
      INTEGER      kCO2ppmv
      PARAMETER (kCO2ppmv           = 400)
      PARAMETER (kCO2ppmvFile       = '/asl/data/kcarta_sergio/KCDATA/General/refgas2_400ppmv')
      PARAMETER (kCO2ppmvFileBack   = '/asl/data/kcarta_sergio/KCDATA/General/refgas2Back_400ppmv')
      PARAMETER (kCO2ppmvFileBackUA = '/asl/data/kcarta_sergio/KCDATA/General/refgas2BackUA_400ppmv')

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! this is for the NLTE files
! >>>>>>>>>>> ignore if you have v1.10 or less <<<<<<<<<<<<<<<<<<<<<<<<<<<
! kMaxPtsBox   == for NLTE, kcarta does 5 point box car integration
! so use 5 times asmany points, plus two extra points on either side
! kCARTA also tries to figure out which is the best ergression profile to use
! kBoxCarUse tells the code how many points to bloat things by
      INTEGER kMaxPtsBox,kRegrProf,kBoxCarUse
      PARAMETER (kBoxCarUse=5)
      PARAMETER (kMaxPtsBox=kMaxPts*kBoxCarUse,kRegrProf=48)
! to do stuff at 0.0005 cm-1 spacing, need to "bloat" optical depths
! if kBloatPts == 1, then cannot bloat up stuff!!
      INTEGER kBloatPts
! high res mode; 0.0005 cm-1 spacing
      PARAMETER (kBloatPts=kMaxPts*kBoxCarUse)
! space saver; everything at 0.0025 cm-01
!      PARAMETER (kBloatPts=1)
! kUpperAtmRefPath == path to upper atm 100 layers reference profiles
!                  == profiles were used in making upper atm kCARTA database
      CHARACTER*80 caUpperAtmRefPath
      PARAMETER (caUpperAtmRefPath= '/asl/data/kcarta_sergio/KCDATA/NLTE/UA/')
! kAuxNLTERefsPath = path to some US STd reference profiles which include LA,UA
      CHARACTER*80 caAuxNLTERefsPath
      PARAMETER (caAuxNLTERefsPath = '/asl/data/kcarta_sergio/KCDATA/NLTE/LA/')

!*********************
! the LineMix,LineParam  and weak CO2 lines
! this is where the weak background compressed database files are
! note we have tested 3 versions so far :
!   (a) may2004 : leave out 2350,2351,2352,2310,2311,2320,2321           Voigt
!   (b) dec2004 : leave out 2350,2351,2352,2310,2311,2320,2321,2353,2354 Voigt
!                 compressed version seems to have been blown away
!   (c) dec2004 : leave out 2350,2351,2352,2310,2311,2320,2321,2353,2354 Cousin
!   (d) sep2005 : leave out 2350,2351,2352,2310,2311,2320,2321,2353,2354 Cousin
!               : leave out 2210,2220,2230,2240...2280 at urging of Manuel
!   (e) mar2018, H2016 : leave out 2350,2351,2352,2310,2311,2320,2321,2353,2354 Cousin
!                      : leave out 2210,2220,2230,2240...2280 at urging of Manuel
! ie in (a),(b) the weak lines used the Voight lineshape, while (c) and hopefully (d,e) uses the
!   Cousin lineshape for the weaklines, as this is what GENLN2 does
! /home/motteler/absdat is actually a symlink to /taro/s2/motteler/abstmp
!   where some of the above versions reside

! this is where the strong band line params are
! in the files here are stored the HITRAN line params (stren, freq, width etc) for 19 bands
! this name should be self consistent with "caaStrongLines" in nm_nonlte of namelist file
      CHARACTER*80 caStrongLineParams
      PARAMETER (caStrongLineParams= &
               '/asl/data/kcarta_sergio/KCDATA/NLTE/AIRSCO2/CO2_H16/co2_allpqr_')

! these compressed background OD files have 19 NLTE bands removed
! this is where we have lower atm weakline database
      CHARACTER*80 caWeakCO2Path,caWeakUpperAtmCO2Path
      PARAMETER (caWeakCO2Path = '/asl/data/kcarta_sergio/BACKGND_COUSIN/fbin/etc.ieee-le/400ppmv_H16/')
! this is where the upper atm weakline database lies
      PARAMETER (caWeakUpperAtmCO2Path = &
         '/asl/data/kcarta_sergio/BACKGND_COUSIN_UPPER/fbin/etc.ieee-le/400ppmv_H16/')
! older H2008? exists /asl/data/kcarta_sergio/BACKGND_COUSIN/fbin/etc.ieee-le/400ppmv/
! older H2008? exists /asl/data/kcarta_sergio/BACKGND_COUSIN_UPPER/fbin/etc.ieee-le/400ppmv/

! this is where the strong band linemix strengths are ... files made by SPECTRA/CO2_COMMON/y1s.m
! see /home/sergio/KCARTA/SRC/NONLTE/M_Files_for_kcarta_NLTE_LBL_runs/ReadmeBlog
      CHARACTER*120 caLineMixDir
      PARAMETER (caLineMixDir='/asl/data/kcarta_sergio/KCDATA/NLTE/AIRSCO2/LINEMIX_H16_400/')

!*************************
! caUA_US_STD_400ppmv has the US STD profile (for 400 ppmv) for UA CO2
! caLA_US_STD_385ppmv has the US STD profile (for 385 ppmv) for LA CO2
! this is useful when doing LBL NLTE calcs
! these were originally caUA_US_STD_385ppmv and caLA_US_STD_385ppmv, all in
! SRCV1.20_f90/kreadVTprofiles.f or in SRCv1.18/kreadVTprofiles.f
      CHARACTER*80 caUA_US_STD,caLA_US_STD
      PARAMETER (caUA_US_STD = '/asl/data/kcarta_sergio/KCDATA/NLTE/UA/us_std_prof_ua_400ppmv')
      PARAMETER (caLA_US_STD = '/asl/data/kcarta_sergio/KCDATA/NLTE/LA/us_std_prof_la_400ppmv')

!************************
! this tells the code how many layers/levels to expect in the NLTE profile
      INTEGER kNLTEProfLayer
      PARAMETER (kNLTEProfLayer= 150)

!************************
! this is where the Fast Model NLTE coeffs are
       CHARACTER*120 kSartaNLTE
! SARTAv106 version, only has 6 predictors (assumes co2 = 370ppmv)
! PARAMETER (kSartaNLTE = '/asl/data/kcarta_sergio/KCDATA/NLTE/SARTA_COEFS/setnte_oct05.le.dat')
! SARTAv108 version, has 7 predictors (assumes co2 >= 370ppmv)
! see incFTC_airs_apr08_m130_m150_template_cal_exper.f in
! /asl/packages/sartaV108/Src_rtpV201
       PARAMETER (kSartaNLTE = &
           '/asl/data/kcarta_sergio/KCDATA/NLTE/SARTA_COEFS/nonLTE7_m150.le.dat')

!*********************
!*********************
!*********************
!c this is where the compressed NLTE (OD, planck) files are, for LOWER and UPPER atm
! this is not working, so may get rid of this eventually
! the files are ODs, PlanckCoeffs, as a function of solar zenith angle
       CHARACTER*120 kCompressedNLTE_LA,kCompressedNLTE_UA
       PARAMETER (kCompressedNLTE_LA = '/asl/data/kcarta_sergio/KCDATA/NLTE/LA_UA_kcomp/')
       PARAMETER (kCompressedNLTE_UA = '/asl/data/kcarta_sergio/KCDATA/NLTE/LA_UA_kcomp/')

!*********************
! these are really NOT USED ANYMORE can ignore this in v1.18 and v1.20
! these are really NOT USED ANYMORE can ignore this in v1.18 and v1.20
! these are really NOT USED ANYMORE can ignore this in v1.18 and v1.20
! kRegrPath == path to regression profiles that code needs if it guesses VT
! the NLTE vib temp profiles
      CHARACTER*80 kRegrFile
      PARAMETER (kRegrFile = '/asl/data/kcarta_sergio/KCDATA/TestProf/rtp_regress.op.rtp')
! kLOPEZPUERTAS = path to Manuel Lope Puertas files, for regression fits
      CHARACTER*80 kLopezPuertas
      PARAMETER (kLopezPuertas = &
       '/home/sergio/KCARTA/NONLTE2/sergio/VT_48PROFILES/sergio_merge/')
! kNLTEPolyfits = path to where the polynomial fits to NLTE profiles are
      CHARACTER*120 kNLTEPolyFits
      PARAMETER (kNLTEPolyFits = &
       '/home/sergio/KCARTA/NONLTE2/sergio/VT_48PROFILES/NLTE_POLYFITS/')

!***********************************************************************
!************************* OTHER SPECTRAL REGIONS **********************
! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
! >>>>>>>>>>>>>>>>> little endian vs big endian data files <<<<<<<<<<<<<
! \\\ this is for the newer gas paths; see pre_definedparam.f90 for the  ////
! \\\ prefix "m","n","v" etc; see       s_misc.f                      ////
! \\\ these files copied from                                         ////
! \\\     /strowdata1/s1/sergio/OLD_RUN8_NIRDATABASE/blah/fbin/gah    ////

! !!! f = 020_30 cm-1, at 0.00005 cm-1 spacing (= 0.5 cm-1 chunk span)
      CHARACTER*80 kWaterPathf,kCompPathf,kCKDPathf
      PARAMETER (kWaterPathf = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR15_30/h2o.ieee-le/')
      PARAMETER (kCompPathf  = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR15_30/etc.ieee-le/')
      PARAMETER (kCKDPathf   = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR15_30/etc.ieee-le/')

! !!! g = 030_50 cm-1, at 0.00010 cm-1 spacing (= 1.0 cm-1 chunk span)
      CHARACTER*80 kWaterPathg,kCompPathg,kCKDPathg
      PARAMETER (kWaterPathg = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR30_50/h2o.ieee-le/')
      PARAMETER (kCompPathg  = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR30_50/etc.ieee-le/')
      PARAMETER (kCKDPathg   = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR30_50/etc.ieee-le/')

! !!! h = 050_80 cm-1, at 0.00015 cm-1 spacing (= 1.5 cm-1 chunk span)
      CHARACTER*80 kWaterPathh,kCompPathh,kCKDPathh
      PARAMETER (kWaterPathh = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR50_80/h2o.ieee-le/')
      PARAMETER (kCompPathh  = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR50_80/etc.ieee-le/')
      PARAMETER (kCKDPathh   = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR50_80/etc.ieee-le/')

! !!! j = 080_150 cm-1, at 0.00025 cm-1 spacing (= 2.5 cm-1 chunk span)
      CHARACTER*80 kWaterPathj,kCompPathj,kCKDPathj
      PARAMETER (kWaterPathj = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR80_150/h2o.ieee-le/')
      PARAMETER (kCompPathj  = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR80_150/etc.ieee-le/')
      PARAMETER (kCKDPathj   = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR80_150/etc.ieee-le/')

! !!! k = 140_310 cm-1, at 0.0005 cm-1 spacing (= 05 cm-1 chunk span)
      CHARACTER*80 kWaterPathk,kCompPathk,kCKDPathk
      PARAMETER (kWaterPathk = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR140_310/h2o.ieee-le/')
      PARAMETER (kCompPathk  = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR140_310/etc.ieee-le/')
      PARAMETER (kCKDPathk   = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR140_310/etc.ieee-le/')

! !!! p = 300_510 cm-1, at 0.0010 cm-1 spacing (= 10 cm-1 chunk span)
      CHARACTER*80 kWaterPathp,kCompPathp,kCKDPathp
      PARAMETER (kWaterPathp = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR300_510/h2o.ieee-le/')
      PARAMETER (kCompPathp  = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR300_510/etc.ieee-le/')
      PARAMETER (kCKDPathp   = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR300_510/etc.ieee-le/')

! !!! q = 500_605 cm-1, at 0.0015 cm-1 spacing (= 15 cm-1 chunk span)
      CHARACTER*80 kWaterPathq,kCompPathq,kCKDPathq
      PARAMETER (kWaterPathq = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR500_605/h2o.ieee-le/')
      PARAMETER (kCompPathq  = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR500_605/etc.ieee-le/')
      PARAMETER (kCKDPathq   = '/asl/data/kcarta_sergio/H2012.ieee-le/FIR500_605/etc.ieee-le/')

! !!! s = 2830-3380 cm-1, at 0.0025 cm-1 spacing (= 25 cm-1 chunk span)
! !!! note we link to hdo.ieee-le instead of h2o_ALLISO.ieee-le
      CHARACTER*80 kWaterPaths,kCompPaths,kCKDPaths
      PARAMETER (kWaterPaths = '/asl/data/kcarta_sergio/H2012.ieee-le/NIR2830_3580/hdo.ieee-le/')
      PARAMETER (kCompPaths  = '/asl/data/kcarta_sergio/H2012.ieee-le/NIR2830_3580/etc.ieee-le/')
      PARAMETER (kCKDPaths   = '/asl/data/kcarta_sergio/H2012.ieee-le/NIR2830_3580/etc.ieee-le/')

! !!! m = 3550-5550 cm-1, at 0.01 cm-1 spacing (= 100 cm-1 chunk span)
      CHARACTER*80 kWaterPathm,kCompPathm,kCKDPathm
      PARAMETER (kWaterPathm = '/asl/data/kcarta_sergio/H2012.ieee-le/OTHERBANDS/NIR3550_5550/h2o.ieee-le/')
      PARAMETER (kCompPathm  = '/asl/data/kcarta_sergio/H2012.ieee-le/OTHERBANDS/NIR3550_5550/etc.ieee-le/')
      PARAMETER (kCKDPathm   = '/asl/data/kcarta_sergio/H2012.ieee-le/OTHERBANDS/NIR3550_5550/etc.ieee-le/')

! !!! n = 5550-8350 cm-1, at 0.015 cm-1 spacing (= 150 cm-1 chunk span)
      CHARACTER*80 kWaterPathn,kCompPathn,kCKDPathn
      PARAMETER (kWaterPathn = '/asl/data/kcarta_sergio/H2012.ieee-le/OTHERBANDS/NIR5550_8200/h2o.ieee-le/')
      PARAMETER (kCompPathn  = '/asl/data/kcarta_sergio/H2012.ieee-le/OTHERBANDS/NIR5550_8200/etc.ieee-le/')
      PARAMETER (kCKDPathn   = '/asl/data/kcarta_sergio/H2012.ieee-le/OTHERBANDS/NIR5550_8200/etc.ieee-le/')

! !!! o = 8250-12250 cm-1, at 0.025 cm-1 spacing (= 250 cm-1 chunk span)
      CHARACTER*80 kWaterPatho,kCompPatho,kCKDPatho
      PARAMETER (kWaterPatho = '/asl/data/kcarta_sergio/H2012.ieee-le/OTHERBANDS/NIR8250_12250/h2o.ieee-le/')
      PARAMETER (kCompPatho  = '/asl/data/kcarta_sergio/H2012.ieee-le/OTHERBANDS/NIR8250_12250/etc.ieee-le/')
      PARAMETER (kCKDPatho   = '/asl/data/kcarta_sergio/H2012.ieee-le/OTHERBANDS/NIR8250_12250/etc.ieee-le/')

! !!! v = 12000-25000 cm-1, at 0.0500 cm-1 spacing (= 500 cm-1 chunk span)
      CHARACTER*80 kWaterPathv,kCompPathv,kCKDPathv
      PARAMETER (kWaterPathv = '/asl/data/kcarta_sergio/H2004_otherbands.ieee-le/VIS12000_25000/h2o.ieee-le/')
      PARAMETER (kCompPathv  = '/asl/data/kcarta_sergio/H2004_otherbands.ieee-le/VIS12000_25000/etc.ieee-le/')
      PARAMETER (kCKDPathv   = '/asl/data/kcarta_sergio/H2004_otherbands.ieee-le/VIS12000_25000/etc.ieee-le/')

! !!! u = 25000-44000 cm-1, at 0.1000 cm-1 spacing (= 1000 cm-1 chunk span)
      CHARACTER*80 kWaterPathu,kCompPathu,kCKDPathu
      PARAMETER (kWaterPathu = '/asl/data/kcarta_sergio/H2004_otherbands.ieee-le/UV25000_45000/h2o.ieee-le/')
      PARAMETER (kCompPathu  = '/asl/data/kcarta_sergio/H2004_otherbands.ieee-le/UV25000_45000/etc.ieee-le/')
      PARAMETER (kCKDPathu   = '/asl/data/kcarta_sergio/H2004_otherbands.ieee-le/UV25000_45000/etc.ieee-le/')

!************************************************************************
!************************************************************************
!************************************************************************

! --------- > (C) these are the extra needed files
! also need paths to where the xsec, CKD and Solar Radiance Files are
      CHARACTER*80 kSolarPath,kXsecFile
      PARAMETER (kSolarPath = '/asl/data/kcarta_sergio/KCDATA/General/SOLARieee_le/')
      PARAMETER (kXsecFile  = '/asl/data/kcarta_sergio/KCDATA/General/xsecdata.dat.intel')

! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

! this is how many layers are in the user profile
      INTEGER kProfLayer
!      PARAMETER (KProfLayer=115)  !!fine lower layers - temperature inversiom
!      PARAMETER (KProfLayer=43)   !!testing Dave Edwards NLTE
!      PARAMETER (KProfLayer=97)   !!testing Dave Edwards NLTE
!      PARAMETER (KProfLayer=120)   !!NLTE so all layers <= 1.25 km thick
      PARAMETER (KProfLayer=100)  !!regular AIRS layers

! now keep in mind kMaxLayer = 100
! so this is used when kProfLayer ~= 100 !!!!!!
      INTEGER kMaxProfLayer
      PARAMETER (kMaxProfLayer=max(kMaxLayer,kProfLayer))
!      PARAMETER (kMaxProfLayer=100)

! kMaxPrint == max number of printing options that can be read in
! kMaxAtm   == max number of atmosphers we do radiance calculations for
! kGasStore == max number of gases we allocate storage for
!              (from GASFIL + XSCFIL + WaterSelf + WaterFor <= kMaxGas)
! kMixFilRows== max number of mixfil rows that can be read in
      INTEGER kMaxAtm,kGasStore,kMixFilRows,kMaxPrint
      PARAMETER (kMaxAtm=8,kGasStore=80,kMixFilRows=kProfLayer*2)
      PARAMETER (kMaxPrint=10)

! kEmsRegions=how many wavenumber dependent regions can be read in from
!             emissivity file
      INTEGER kEmsRegions
      PARAMETER (kEmsRegions=2000)

! this is if the user wants to do Jacobians
! kMaxDQ = max number of gases we do d/dq for (GasID's 1..6) HUGE MEMORY!!!
! kProfLayerJac = kProfLayer if Jacobians on, 1 otherwise
! kMaxPtsJac    = kMaxPts=10000 if Jacobians on, 1 otherwise
      INTEGER kMaxDQ,kProfLayerJac,kMaxPtsJac
      PARAMETER (kMaxDQ=2,kProfLayerJac=kProfLayer,kMaxPtsJac=kMaxPts)
! when kProfLayerJac,kMaxPtsJac are set to 1, this is "space saver" mode
!      PARAMETER (kMaxDQ=1,kProfLayerJac=1,kMaxPtsJac=1)

! this is if the user wants to do scattering computations
! kMaxClouds = max number of clouds the user defines
      INTEGER kMaxClouds
      PARAMETER (kMaxClouds=3)
! kMaxLayersPerCloud = max number of layers each cloud can occupy
! set it to kProfLayer if you are reading in arbitrary ECMWF profiles
      INTEGER kCloudLayers
      PARAMETER (kCloudLayers=kProfLayer)

! this parameter tells the code whether or not the Xsec gases are in the new
! Hitran98 kcompressed Format (+1), or in the older Hitran92 file format(-1)
      INTEGER kXsecFormat
      PARAMETER (KXsecFormat=+1)

!*************************
! this is potentially to use kCARTA for different planets, in future KCARTA versions
! Numbers here are for Earth, planet 03
      INTEGER kPlanet
      PARAMETER (kPlanet = 03)

! Default kCARTA database for Earth is in Toffsets of 10K from each other
      REAL kTempOffSet_database
      PARAMETER (kTempOffSet_database = 10.0)

! 6.785087652174316e-5 = pi(sun diam/sun dist)/asl/data/kcarta_sergio2 = pi*((0.6951e9/149.57e9)/asl/data/kcarta_sergio2)
!      we also need to multiply by muSat, and then divide by PI to use
!      pencil beam intensity instead of Liou's fat beam flux ??
!      6.785087652174316e-5 = (sun diam/sun dist)/asl/data/kcarta_sergio2 = solid angle
!      in some code this is deivided by PI so watch out!!
!        rOmegaSun = kPi*((0.6951e9/149.57e9)**2)/kPi
!        rOmegaSun = 6.785087652174316e-5/kPi
!        rOmegaSun = 6.785087652174316e-5      version on Jan 2006
      DOUBLE PRECISION kOmegaSun
      PARAMETER (kOmegaSun = 6.785087652174316d-5)

! kHeavyWater is the isotopic abundance for HDO from
!  /asl/data/hitran/HITRAN04/HITRAN2k.pdf, pg 5
      REAL kHeavyWaterAbundance
      PARAMETER (kHeavyWaterAbundance = 0.00031069)
! this is specific heat capaicity of air at constant pressure
! value is 1.005e3 J kg-1 K-1 = 1.005e6 mJ kg-1 K-1
! note RRTM uses 1.00464, so this is a 0.1% difference
      REAL kSp_heat_air_cp
      PARAMETER (kSp_heat_air_cp = 1.005e3*1e3)
! sp heat const of dry air, in  J K−1 kg−1 = R/Molecular mass = 8.31/(28.955/1000)
      REAL kSpecificGasDryAir
      PARAMETER (kSpecificGasDryAir = 287.00)

! gravity, mostly used in flux computations, together with kSp_heat_air_cp,  units m/s2
! Re = earth radius, also mostly used in flux computations,  units km
! kMolarMass = molar mass of atmosphere in g/mol eg for Earth 79% N2, 21% 02
!   we have 0.79*28 + 0.21*32 = 28.84 g/mol
!   or   mass=(28*0.78084)+(32*0.20948) + (40*0.00934) + (44*0.00033)
! kScaleHgt = Scale Height of atm (how quickly does pressure decrease) in km, for isothermal atm
!  eg for Earth we have Ho = R T / g M = 8.31 * 287 / (9.8 * 28.8/1000) in meters = 8.45 km
! kStempMin,kStempMax = what you would reasonably expect for stemp
      REAL kGravity,kPlanetRadius,kScaleHgt,kAtmMolarMass
      PARAMETER (kGravity = 9.80665, kPlanetRadius = 6370.00)
      PARAMETER (kScaleHgt = 8.0, kAtmMolarMass = 28.966)
      REAL kStempMin,kStempMax
      PARAMETER (kStempMin = 200.0,kStempMax = 330.0)

! this has the AFGL levels profiles for "layers" code
! if you set this as 'DNE' then ReadRefProf_Units_laysORlevs will only call the LAYERS ref prof
       CHARACTER*80 kcaLevsRefProf
       PARAMETER (kcaLevsRefProf = '/home/sergio/KCARTA/INCLUDE/glatm_16Aug2010.dat')

!************************************************************************
!************* cccc USER DEFINED INFORMATION cccc ***********************
!******************* set these as desired *******************************
!************************************************************************

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!! POST DEFINED PARAMETERS!! DO NOT TOUCH!! !!!!!!!!!!!!!!!!!
!!!!                                                                  !!!
      include '../INCLUDE/post_definedparam.f90'                         !!!
!!!!                                                                  !!!
!!!!!!!!!!!!!! POST DEFINED PARAMETERS!! DO NOT TOUCH!! !!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
