!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! this file does the interfacing between K.F.Evan's RTSPEC array dimensions,
! and those of kCARTA

! this file does the interfacing between Stamnes et al DISORT array dimensions,
! and those of kCARTA

      include '../INCLUDE/kcartaparam.f90'

!ccccccccccccccccccccc ORIGINAL rtspec variables ccccccccccccccccccccc
!c
!cC         Scattering table variables:
!c      INTEGER  MAXTAB, MAXGRID, MAXSCAT
!c      PARAMETER (MAXTAB=10*25*500, MAXGRID=10000, MAXSCAT=5)
!c      INTEGER  NMUOBS(MAXSCAT), NDME(MAXSCAT), NWAVETAB(MAXSCAT)
!c      REAL     MUTAB(MAXGRID,MAXSCAT)
!c      REAL     DMETAB(MAXGRID,MAXSCAT), WAVETAB(MAXGRID,MAXSCAT)
!c      REAL     MUINC(2)
!c      REAL     TABEXTINCT(MAXTAB,MAXSCAT), TABSSALB(MAXTAB,MAXSCAT)
!c      REAL     TABASYM(MAXTAB,MAXSCAT)
!c      REAL     TABPHI1UP(MAXTAB,MAXSCAT), TABPHI1DN(MAXTAB,MAXSCAT)
!c      REAL     TABPHI2UP(MAXTAB,MAXSCAT), TABPHI2DN(MAXTAB,MAXSCAT)
!c
!cC         Radiative transfer variables:
!c      INTEGER  MAXABSNU, MAXNZ, MAXSPEC
!c      PARAMETER (MAXABSNU=100000, MAXNZ=100, MAXSPEC=10)
!c      INTEGER NUMSPEC, NSCATTAB, NCLDLAY, NABSNU, NLEV
!c      INTEGER ICLDTOP, ICLDBOT, IOBS, ISCATTAB(MAXNZ)
!c      INTEGER I, J, L, M, JNU1, JNU2
!c      LOGICAL OUTTB(MAXSPEC), OUTTRIANG(MAXSPEC), BINARYABSFILE
!c      REAL    ZOBS, MUOBS, ZTOP, IWP(MAXNZ), DME(MAXNZ)
!c      REAL    SFCTEMP, SFCEMIS
!c      REAL    ONU, RADOBS, OUTRAD
!c      REAL    HEIGHT(MAXNZ), TEMP(MAXNZ), ABSPROF(MAXNZ,MAXABSNU)
!c      REAL*8  ABSNU1, ABSNU2, ABSDELNU
!c      REAL*8  OUTNU1(MAXSPEC), OUTNU2(MAXSPEC), OUTDELNU(MAXSPEC)
!c      REAL*8  WAVENO, ONU1, ONU2, INVOUTDELNU, WT1, WT2
!c      REAL*8  SUMWT1, SUMWT2, SUMRAD1, SUMRAD2
!c      CHARACTER*100 SCATFILE(MAXSCAT), ABSFILE(MAXSPEC), OUTPUTFILE
!c      CHARACTER*1   RTMODEL, ABSTYPE
!c      CHARACTER*24  OUTUNITS, OUTAVERAGING

!ccccccccccccccccccccc interfaced rtspec dimensions ccccccccccccccccccccc
!         Scattering table variables:
!      need MAXTAB >= (NMUOBS*NDME*NWAVE)
      INTEGER  MAXTAB, MAXGRID, MAXSCAT
!      PARAMETER (MAXTAB=10*25*500*8, MAXGRID=kMaxPts, MAXSCAT=kMaxClouds)
!      PARAMETER (MAXTAB=10*25*500, MAXGRID=kMaxPts,MAXSCAT=kMaxClouds)
!      PARAMETER (MAXTAB=10*10*2600, MAXGRID=kMaxPts, MAXSCAT=kMaxClouds)
!      PARAMETER (MAXTAB=10*10*2200, MAXGRID=kMaxPts, MAXSCAT=kMaxClouds)
      PARAMETER (MAXTAB=10*10*2600, MAXGRID=kMaxPts, MAXSCAT=kMaxClouds)

!         Radiative transfer variables:
      INTEGER  MAXABSNU, MAXNZ
! maxabsnu = number of frequency points
! maxnz    = max number of levels ==== 1 + max number of layers
      PARAMETER (MAXABSNU=kMaxPts, MAXNZ=kProfLayer+1)
!this is for the number of phase function points
      INTEGER   MAXPHASE
      PARAMETER (MAXPHASE=128)  !read this many phase points each time

!************************************************************************

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! this file also does the interfacing between DISORT and KCARTA arrays

!  LOCAL SYMBOLIC DIMENSIONS (have big effect on storage requirements):
!
!       MXCLY  = Max no. of computational layers
!       MXULV  = Max no. of output levels
!       MXCMU  = Max no. of computation polar angles
!       MXUMU  = Max no. of output polar angles
!       MXPHI  = Max no. of output azimuthal angles
!       MXSQT  = Max no. of square roots of integers (for LEPOLY)

      INTEGER maxcly             !max number of computational layers
      INTEGER maxulv             !max number of output user levels
      INTEGER maxcmu             !max number of computational polar angles
                                 !(should be EVEN)
      INTEGER maxumu             !max number of user polar angles
      INTEGER maxphi             !max number of user azimuth angles
      INTEGER maxsqt             !max number of square roots of integers
      INTEGER maxmom             !max number of legendre polys=streamnums

!      PARAMETER (maxcly = kProfLayer, maxulv = maxcly+1, maxmom = 299 )
      PARAMETER (maxphi = 3, maxumu = 10)
      PARAMETER (maxsqt = 1000, maxcmu = 12)
      PARAMETER (maxcly = kProfLayer, maxulv = maxcly+1, maxmom = 1 )
! space saver dimensions!!!!!!!!!!!!!!!!!
!      PARAMETER (maxphi = 2, maxumu = 2)
!      PARAMETER (maxsqt = 10, maxcmu = 2)
!      PARAMETER (maxcly = 1, maxulv = maxcly+1, maxmom = 1 )

! raUseEmissivity is emissivity vector assigned for current 25 cm-1 chunk
! raBiDirRefl     is bidirectilnal reflectivity
! DISORTsurfpress is surface pressure
      REAL DISORTsurfPress
      INTEGER DISORTiI
      DOUBLE PRECISION DISORTraBiDirRefl(kMaxPts)

      COMMON/DISORTBLK1/DISORTiI
      COMMON/DISORTBLK2/DISORTsurfPress
      COMMON/DISORTBLK3/DISORTraBiDirRefl
